﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace howto_select_bg_color
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // Initialize the background color menu item.
        private void Form1_Load(object sender, EventArgs e)
        {
            // Use light colors plus the initial background
            // color for the dialog's custom colors.
            int bg_color =
                BackColor.B * 256 * 256 +
                BackColor.G * 256 +
                BackColor.R;
            int[] bg_colors = {
                bg_color, 0xFFC0C0, 0xFFE0C0, 0xFFFFC0, 0xC0FFC0,
                0xC0FFFF, 0xC0C0FF, 0xFFC0FF, 0xE0E0E0, 0xFF8080,
                0xFFC080, 0xFFFF80, 0x80FF80, 0x80FFFF, 0x8080FF,
                0xFF80FF
            };
            cdBgColor.CustomColors = bg_colors;

            // Display the current color on the menu item.
            SetBgColor(BackColor);
        }

        private void mnuSettingsBgColor_Click(object sender, EventArgs e)
        {
            // (This won't work if the color isn't on the dialog.)
            // Show the current color.
            cdBgColor.Color = BackColor;

            // Display the dialog.
            if (cdBgColor.ShowDialog() == DialogResult.OK)
            {
                SetBgColor(cdBgColor.Color);
            }
        }

        // Set the background color and update the men item.
        private void SetBgColor(Color color)
        {
            // Use the color.
            BackColor = color;

            // Make an image to show a color sample.
            const int wid = 24; // Image width.
            Bitmap bm = new Bitmap(wid, wid);
            using (Graphics gr = Graphics.FromImage(bm))
            {
                gr.Clear(color);
                gr.DrawRectangle(Pens.Black,
                    0, 0, wid - 1, wid - 1);
                mnuSettingsBgColor.Image = bm;
            }
        }
    }
}
